<?php
// Function to recursively add files and folders to a zip file
function addFilesToZip($folder, &$zip) {
    $handle = opendir($folder);
    while (false !== ($file = readdir($handle))) {
        if ($file != "." && $file != "..") {
            $path = $folder . '/' . $file;
            if (is_dir($path)) {
                addFilesToZip($path, $zip);
            } else {
                $zip->addFile($path);
            }
        }
    }
    closedir($handle);
}

// Check if form is submitted
if (isset($_POST['submit'])) {
    // Create a new ZipArchive instance
    $zip = new ZipArchive();
    
    // Define the path and name of the output zip file
    $outputFile = 'files.zip';
    
    // Open the zip file for creating
    if ($zip->open($outputFile, ZipArchive::CREATE | ZipArchive::OVERWRITE) !== TRUE) {
        exit("Cannot create zip archive");
    }
    
    // Check if "Select All" option is checked
    $selectAll = isset($_POST['select_all']);
    
    // Loop through each selected file/folder
    foreach ($_POST['selected_items'] as $item) {
        // Check if it's a directory
        if (is_dir($item)) {
            // Add files and folders inside the directory recursively
            addFilesToZip($item, $zip);
        } else {
            // Add the selected file to the zip archive
            $zip->addFile($item);
        }
    }
    
    // Close the zip file
    $zip->close();
    
    echo "Files successfully zipped!";
}

// Get the root directory
$directory = $_SERVER['DOCUMENT_ROOT'];
?>

<!-- HTML form -->
<form method="post" id="zipForm">
    <label>
        <input type="checkbox" name="select_all" id="select_all"> Select All
    </label>
    <br>
    <?php
    // Scan the directory for files and folders
    $items = scandir($directory);
    
    foreach ($items as $item):
        // Exclude hidden files and folders
        if ($item != "." && $item != ".." && !is_file($directory . '/' . $item . '/.')):
            ?>
            <label>
                <input type="checkbox" name="selected_items[]" value="<?php echo $directory . '/' . $item; ?>">
                <?php
                if (is_dir($directory . '/' . $item)) {
                    echo "<strong>" . $item . "</strong>";
                } else {
                    echo $item;
                }
                ?>
            </label>
            <br>
            <?php
        endif;
    endforeach;
    ?>
    <br>
    <input type="submit" name="submit" value="Create Zip">
</form>

<script>
    // JavaScript code for "Select All" functionality
    var selectAllCheckbox = document.getElementById('select_all');
    var checkboxes = document.querySelectorAll('input[name="selected_items[]"]');
    
    selectAllCheckbox.addEventListener('change', function() {
        checkboxes.forEach(function(checkbox) {
            checkbox.checked = selectAllCheckbox.checked;
        });
    });
</script>
